
##########################
### EXAMPLE: various tuple operations (slide 6)
##########################
#print('Tuple or sequence examples')
#seq = (2, 'a', 4, (1, 2))
#print(len(seq))
#print(seq[2] + 1)
#print(seq[3])
#i = 2
#print(seq[i - 1])
#print(seq[-1])
##print(seq[4])
#
#print(seq[1])
#print(seq[:-1])
#print(seq[1:3])
#
#for e in seq:
#    print(e)

#########################
## EXAMPLE: returning a tuple (slide 8)
#########################
def quotient_and_remainder(x, y):
    q = x // y
    r = x % y
    return (q, r)

#(quot, rem) = quotient_and_remainder(4,5)
#print(quot)
#print(rem)
#both = quotient_and_remainder(4,5)
#print(both)

#########################
## EXAMPLE: various list operations (slide 11 through 27)
## put print(L) at different locations to see how it gets mutated
#########################
#print('List examples')
#L1 = [2,1,3]
#L2 = [4,5,6]
#L3 = L1 + L2
#L1.extend([0,6])
#
#L = [2,1,3,6,3,7,0]
#L.remove(2)
#L.remove(3)
#del(L[1])
#print(L.pop())
#
#s = "I<3 cs"
#print(list(s))
#print(s.split('<'))
#L = ['a', 'b', 'c']
#print(''.join(L))
#print('_'.join(L))
#
#L=[9,6,0,3]
#print(sorted(L))
#L.sort()
#L.reverse()
#
#L = [2,1,3,6,3,7,0] 
#L.pop(5)
#print(L)
#L.remove(3)
#print(L)
#L.pop()
#print(L)
#
#L = [1,2,3,4]
#i = 0
## infinite loop
##for e in L:
##    L.append(i)
##    i += 1
##print(L)
#
#L = [1,2,3,4]
#i = 0
#for e in L:
#    L = L + L
#print(L)


#########################
## EXAMPLE: aliasing (slide 36)
#########################
#a = 1
#b = a
#print(a)
#print(b)
#
#warm = ['red', 'yellow', 'orange']
#hot = warm
#hot.append('pink')
#print(hot)
#print(warm)

#########################
## EXAMPLE: cloning (slide 37)
#########################
#cool = ['blue', 'green', 'grey']
#chill = cool[:]
#chill.append('black')
#print(chill)
#print(cool)

#########################
## EXAMPLE: sorting with/without mutation (slide 38)
#########################
#warm = ['red', 'yellow', 'orange']
#sortedwarm = warm.sort()
#print(warm)
#print(sortedwarm)
#
#cool = ['grey', 'green', 'blue']
#sortedcool = sorted(cool)
#print(cool)
#print(sortedcool)

#########################
## EXAMPLE: lists of lists of lists... (slide 39)
#########################
#warm = ['yellow', 'orange']
#hot = ['red']
#brightcolors = [warm]
#brightcolors.append(hot)
#print(brightcolors)
#hot.append('pink')
#print(hot)
#print(brightcolors)

###############################
## EXAMPLE: mutating a list while iterating over it (slide 25)
###############################
def remove_dups(L1, L2):
    for e in L1:
        if e in L2:
            L1.remove(e)

#L1 = [1, 2, 3, 4]
#L2 = [1, 2, 5, 6]
#remove_dups(L1, L2)
#print(L1)

###############################
## EXERCISE: Test yourself by predicting what the output is and 
##           what gets mutated then check with the Python Tutor
###############################
#cool = ['blue', 'green']
#warm = ['red', 'yellow', 'orange']
#print(cool)
#print(warm)
#
#colors1 = [cool]
#print(colors1)
#colors1.append(warm)
#print('colors1 = ', colors1)
#
#colors2 = [['blue', 'green'],
#          ['red', 'yellow', 'orange']]
#print('colors2 =', colors2)
#
#warm.remove('red') 
#print('colors1 = ', colors1)
#print('colors2 =', colors2)
#
#for e in colors1:
#    print('e =', e)
#
#for e in colors1:
#    if type(e) == list:
#        for e1 in e:
#            print(e1)
#    else:
#        print(e)
#
#flat = cool + warm
#print('flat =', flat)
#
#print(flat.sort())
#print('flat =', flat)
#
#new_flat = sorted(flat, reverse = True)
#print('flat =', flat)
#print('new_flat =', new_flat)
#
#cool[1] = 'black'
#print(cool)
#print(colors1)

#########################
## EXAMPLE: looping over lists ... (slide 42)
#########################
def total_iter(L):
    result = 0
    for e in L:
        result += len(e)
    return result

def total_recur(L):
    if L == []:
        return 0
    else:
        return len(L[0]) + \
               total_recur(L[1:])
    
#test = ["abc", 'd', "efghi"]
#print(total_length(test))
#print(total_length_recur(test))
               
#########################
## EXAMPLE: lists are naturally recursive (slide 43)
#########################
def my_rev(L):
    if L == []:
        return L
    else:
        return my_rev(L[1:]) + [L[0]]
    
#test2 = ["abc", ['d'], ['e', ['f', 'g']]]
#print(my_rev(test2))





import copy

########################
# making a copy using assignment,
# names point to same object in memory
########################
#
#old_list = [[1,2],[3,4],[5,'foo']]
#new_list = old_list
#
#new_list[2][1] = 6
#
#print("New list:", new_list)
#print("Old list:", old_list)

########################
# making a shallow copy
# creates a new version, containing 
# references (or pointers) to each element
########################

#old_list = [[1,2],[3,4],[5,6]]
#new_list = copy.copy(old_list)
#
#print("New list:", new_list)
#print("Old list:", old_list)
#
#old_list.append([7,8])
#
#print("New list:", new_list)
#print("Old list:", old_list)

# but if change content of an element, 
# it changes both

#old_list[1][1] = 9
#
#print("New list:", new_list)
#print("Old list:", old_list)

########################
# making a deep copy
# creates a new copy, containing 
# new copies of each element
########################

old_list = [[1,2],[3,4],[5,6]]
new_list = copy.deepcopy(old_list)

print("New list:", new_list)
print("Old list:", old_list)

old_list.append([7,8])
old_list[1][1] = 9

print("New list:", new_list)
print("Old list:", old_list)
